<?php

/*
On suppose que le rapport est fait le 1er de chaque mois
*/


function get_bm_figure() {
    $apiKey=file("/etc/bm/bm-core.tok") ;

    $thisList = array() ;
    $excludeUser = array("admin","bmhiddensysadmin") ;

    $serv = new SoapClient('https://uruviel.mclabosse.fr/soap/proxy?wsdl');
    $login = $serv->login(array('arg0' => 'admin0@global.virt', 'arg1' => $apiKey[0], 'arg2' => 'bmStats'));
    $token = $login->return;

    if($token==null || !isset($token->sessionId) || $token->sessionId==null) {
        echo "invalid login/password";
        exit(1);
    } else {
    };


    class UserQuery {
        public $archived = null;
        public $dateBegin = null;
        public $delegationPrefix = null;
        public $directionPrefix = null;
        public $domainId = null;
        public $domainName = null;
        public $email = null;
        public $expirationOp = null;
        public $extId = null;
        public $filterPattern = null;
        public $firstNamePrefix = null;
        public $groupPrefix = null;
        public $id = null;
        public $lastNamePrefix = null;
        public $login = null;
        public $loginPrefix = null;
        public $patterns = null;
        public $phonePrefix = null;
        public $profile = null;
        public $servicePrefix = null;
        public $system = null;
       
        public $quota = null;
        public $mailQuotaUse = null ;
       
        
     }


    $userQuery = new UserQuery();

    $userQuery->domainId != 1 ;

    $users = $serv->findUsers(array('arg0' => $token, 'arg1' => $userQuery));
    
    foreach($users->return as $user) {
        if($user->domain->id != 1 ) {
            if(!in_array($user->login,$excludeUser)) {
            
                $thisDomain    = $user->domain->name ;
                $thisUser      = $user->login ;
                $thisQuota     = $user->quota ;
                $thisQuotaUsed = $user->mailQuotaUse ;
                $thisArchived  = $user->archived ;   
            
                if(isset($user->mailForward)) {
                    if(is_array($user->mailForward)) {
                        $thisAllowed = $user->mailForward->allowed ;
                        $thisEnabled = $user->mailForward->enabled ;
                    };
                };

                if(isset($user->emails->entry))  $this_array[$thisDomain]['mbox']++;
                $this_array[$thisDomain]['account']++;
                if(!empty($thisArchived) ) {
                    $bm_domain_figures[$thisDomain][archive][address][] = $this_login ;
                    $this_array[$thisDomain]['archive']++;
                };
                
                if($thisQuota > 0) $this_array[$thisDomain]['quota'][] = $thisQuota ;
                if($thisQuota > 0) $this_array[$thisDomain]['quota_use'][] = $thisQuotaUsed ;
                if($thisQuota == 0) $this_array[$thisDomain]['quota_unlim']++; 
                if($thisEnabled == "1") $this_array[$thisDomain]['redirected_mbox']++;          

                $this_array[$thisDomain]['archive'] += 0    ;
                $this_array[$thisDomain]['redirected_mbox'] += 0    ;
         
            };
        };
        
        
        foreach (array_keys($this_array) as $thisDomain) {
                
                $thisData = $this_array[$thisDomain] ;
                sort($thisData['quota']) ;
                
                $this_array[$thisDomain]['max_mbox_quota'] =  $thisData['quota'][-1];
                $this_array[$thisDomain]['ceil_quota'] = round((array_sum($thisData['quota'])/$thisData['mbox']),2) ;
                $this_array[$thisDomain]['ceil_quota_used'] = round((array_sum($thisData['quota_use'])/$thisData['mbox']),2) ;         
            
            
        };
        
    };
    
    return $this_array ;
}


function get_percent($a,$b) {
	
	if($b == 0) { $b = 1 ;};	

	$c = ($b - $a)/$b ;
	$c = floor(10000*$c)/100;

	return $c ;
};


function verif_existence_rep($rep)
{
    $PATH=$rep;
    if(!(is_dir($PATH))) {
        $cmd = "mkdir -p $PATH ; chmod -R 755 $PATH  ; chown -R root.www-data $PATH";
        exec($cmd);
    } else {
        $cmd = "chmod -R 755 $PATH ; chown -R root.www-data $PATH ";
        exec($cmd);
    };

};


?>
